#include "nls.ch"
#include "foxdbe.ch"
#include "cdxdbe.ch"
#include "dbfdbe.ch"
#include "common.ch"
#include "dcdialog.ch"

#pragma library ("dclipx.lib")

#define GRA_CLR_BG_GRAU       GRA_CLR_BACKGROUND
#define GRA_CLR_BG_BLAU       GraMakeRGBColor({165,195,243})
#define GRA_CLR_BG_GRUEN      GraMakeRGBColor({225,255,225})
#define GRA_CLR_BG_ORANGE     GraMakeRGBColor({255,219,183})

#define GRA_CLR_DARKYELLOW    GraMakeRGBColor({255,255,128})
#define GRA_CLR_ORANGE        GraMakeRGBColor({255,193,132})
#define GRA_CLR_LIGHTBLUE     GraMakeRGBColor({187,221,255})
#define GRA_CLR_MITTELGRAU    GraMakeRGBColor({195,195,195})

#define GRA_CLR_MYDARKGREEN   GraMakeRGBColor({0,195,104})
#define GRA_CLR_HELLRED       GraMakeRGBColor({255,132,132})
#define GRA_CLR_MYRED         GraMakeRGBColor({217,0,0})
#define BRW_CLR_HEADNORMAL    GraMakeRGBColor({186,214,235})
#define BRW_CLR_HEADSORTBAR   GraMakeRGBColor({57,136,193})
#define BRW_CLR_HEADSELECTED  GraMakeRGBColor({113,170,213})
#define BRW_CLR_HIGHLIGHT     GraMakeRGBColor({255,204,153})

#define BRW_CLR_NONE      {NIL,NIL}
#define BRW_CLR_MARKED    {GRA_CLR_YELLOW,GRA_CLR_DARKGRAY}
#define BRW_CLR_GREEN     {GRA_CLR_DARKGREEN,nil}
#define BRW_CLR_RED       {GRA_CLR_MYRED,nil}
#define BRW_CLR_YELLOW    {GRA_CLR_BLACK,GRA_CLR_YELLOW}
#define BRW_CLR_MARKRED   {GRA_CLR_HELLRED,GRA_CLR_DARKGRAY}
#define BRW_CLR_MARKGREEN {GRA_CLR_GREEN,GRA_CLR_DARKGRAY}

****************************************************************************
FUNCTION Main()
local GetOptions

public oGDL
DCVARGROUP TO M->oGDL NAME "GDLOKAL" ;
   sdelay:=0.01, ;
   cHeadFont:="", ;
   cSayFont:="", ;
   cSayFont2:="", ;
   cSayFont3:="", ;
   cBrwFont:="", ;
   cGetFont:="", ;
   cGetFont2:="", ;
   cGetFont3:="", ;
   cFontSZ:="12.Marlett", ;
   cMenuFont:="8.Arial", ;
   nSayWidth:=0, ;
   nColPixels:=0, ;
   nRowPixels:=0, ;
   nSpFakt:=0, ;
   nBrwHoehe:=0, ;
   color_background:=GRA_CLR_BACKGROUND, ;
   color_title:=GRA_CLR_BLACK, ;
   nDPIFaktor:=GetTextDPI(2), ;
   aResolut:=AppDesktop():currentSize(), ;
   ProgStyle:= 1, ;
   oBtnConf1:=nil, ;
   ToolbarColor:=GraMakeRGBColor({255,255,255})

**************
fvwinit_SetResolut(AppDesktop():currentsize()[2])
**************

DC_BrowPres({ ;
   {XBP_PP_COMPOUNDNAME, M->oGDL:cBrwFont }, ;
   {XBP_PP_COL_DA_FGCLR, GRA_CLR_BLACK }, ;
   {XBP_PP_COL_DA_BGCLR, GRA_CLR_WHITE}, ;
   {XBP_PP_HILITE_FGCLR, GRA_CLR_BLACK }, ;
   {XBP_PP_HILITE_BGCLR, BRW_CLR_HIGHLIGHT }, ;
   {XBP_PP_COL_DA_ROWHEIGHT, M->oGDL:nBrwHoehe }, ;
   {XBP_PP_COL_DA_CELLHEIGHT, M->oGDL:nBrwHoehe }, ;
   {XBP_PP_COL_HA_COMPOUNDNAME, M->oGDL:cHeadFont } ;
  })

*** Farbe fr Browse-Header mit Sort setzen
DC_BrowseSort( { GRA_CLR_BLACK, ;
                 BRW_CLR_HEADNORMAL , ;
                 GRA_CLR_WHITE, ;
                 BRW_CLR_HEADSORTBAR , ;
                 NIL, ;
                 NIL, ;
                 GRA_CLR_WHITE, ;
                 BRW_CLR_HEADSELECTED })


DCGET OPTIONS ;
   SAYWIDTH M->oGDL:nSayWidth ;
   SAYHEIGHT M->oGDL:nRowPixels ;
   SAYOPTIONS XBPSTATIC_TEXT_VCENTER ;
   FONT M->oGDL:cSayFont ;
   SAYFONT M->oGDL:cSayFont ;
   GETFONT M->oGDL:cGetFont ;
   GETHEIGHT M->oGDL:nRowPixels ;
   ROWPIXELS M->oGDL:nRowPixels ;
   ROWSPACE M->oGDL:nRowPixels ;
   COLPIXELS M->oGDL:nColPixels ;
   TABSTOP ;
   CHECKGET ;
   COLOR M->oGDL:color_background ;
   PRESENTATION { { XBP_PP_DISABLED_FGCLR,GRA_CLR_BLACK}, { XBP_PP_DISABLED_BGCLR,M->oGDL:color_background}}

dc_getoptdefault(GetOptions)

select 1
DbUseArea(.F.,DbeSetDefault(), "BAUSTELL","bau",.T.,.F.)
OrdListAdd(".\BAUST1")
dbsetorder(2)
dbgotop()

***********
BauMain("Test")
***********

dbcloseall()
return Nil
****************************************************************************
PROC appsys ; RETURN
****************************************************************************
PROCEDURE BauMain(cTitel)
local GetList:={}, GetOptions, cAlias:=alias(), oBrowse, aSelRec:={}
local rotbed:={|| bau->anzcont>0 .and. !empty(bau->lt_m_dat) .and. bau->mlpflicht="J" .and. bau->lt_d_dat<=bau->lt_m_dat+10}, gruenbed:={|| bau->isr="J"}
local bStdClr:=  {|| iif(ascan(aSelRec,recno())<>0,BRW_CLR_MARKED,BRW_CLR_NONE)}
local bStdClrG:= {|| iif(ascan(aSelRec,recno())<>0,iif(eval(gruenbed),BRW_CLR_MARKGREEN,BRW_CLR_MARKED),(iif(eval(gruenbed),BRW_CLR_GREEN,BRW_CLR_NONE)))}
local bStdClrOk:={|| iif(ascan(aSelRec,recno())<>0,BRW_CLR_MARKED,BRW_CLR_GREEN)}
local bStdClrR:= {|| iif(ascan(aSelRec,recno())<>0,iif(eval(rotbed),BRW_CLR_MARKRED,BRW_CLR_MARKED),(iif(eval(rotbed),BRW_CLR_RED,BRW_CLR_NONE)))}
local bStdClrSp:={|| iif(ascan(aSelRec,recno())<>0,BRW_CLR_MARKED,iif(bau->baucolor<>0,{bau->baucolor,nil},BRW_CLR_NONE))}
local bSortCol:={|a,n,o| dbsetorder(oBrowse:GetColumn(n):cargo[3]), SetAppFocus(oBrowse) }
local area:=dc_GetWorkArea()
local b:=(area[3]-3*M->oGDL:nColPixels)/M->oGDL:nColPixels
local h:=(area[4]-6*M->oGDL:nRowPixels)/M->oGDL:nRowPixels


DCGET OPTIONS ;
      WINDOWHEIGHT area[4] ;
      WINDOWWIDTH area[3] ;
      NORESIZE ;
      HIDE

************
* BROWSE
************
@4.5,0.5 DCBROWSE oBrowse ;
     SIZE b, h ;
     DATA cAlias ;
     CURSORMODE XBPBRW_CURSOR_ROW ;
     PRESENTATION DC_BrowPres() ;
     ITEMSELECTED {|| nil, SetAppFocus(oBrowse) } ;
     FREEZELEFT {1,2,3,4} ;
     TABSTOP ;
     FIT MAX b*M->oGDL:nColPixels

DCBROWSECOL DATA {|| str(bau->baustelle,7) };
            HEADER " Ans-Nr." ;
            WIDTH 5 ;
            CARGO 1 ;
            SORT bSortCol LEFTBUTTON ;
            COLOR bStdClrG ;
            PARENT oBrowse

DCBROWSECOL DATA {|| iif(bau->dokvorh, chr(97),"") } ;
            HEADER "Dok" ;
            COLOR bStdClrOk ;
            FONT M->oGDL:cFontSZ ;
            ALIGN XBPALIGN_HCENTER+XBPALIGN_VCENTER ;
            WIDTH 1.5 ;
            PARENT oBrowse

DCBROWSECOL DATA {|| alltrim(bau->name1) };
            HEADER " Kunde" ;
            WIDTH 18 ;
            CARGO 2 ;
            COLOR bStdClr ;
            SORT bSortCol LEFTBUTTON DEFAULT;
            PARENT oBrowse

DCBROWSECOL DATA {|| alltrim(bau->strasse)+" "+alltrim(bau->strzusatz) } ;
            HEADER " Strasse" ;
            WIDTH 18 ;
            CARGO 3 ;
            COLOR bStdClrSp ;
            SORT bSortCol LEFTBUTTON ;
            PARENT oBrowse

DCBROWSECOL FIELD bau->plz ;
            HEADER " Plz" ;
            WIDTH 4 ;
            CARGO 5 ;
            COLOR bStdClr ;
            SORT bSortCol LEFTBUTTON ;
            PARENT oBrowse

DCBROWSECOL DATA {|| alltrim(bau->ort)+' '+bau->bezirk } ;
            HEADER " Ort/Bezirk" ;
            WIDTH 18 ;
            CARGO 4 ;
            COLOR bStdClr ;
            SORT bSortCol LEFTBUTTON ;
            PARENT oBrowse

DCBROWSECOL FIELD bau->anzcont ;
            HEADER "Beh." ;
            WIDTH 2 ;
            COLOR bStdClrR ;
            PARENT oBrowse

DCBROWSECOL FIELD bau->tele ;
            HEADER " Telefon" ;
            WIDTH 12 ;
            COLOR bStdClr ;
            PARENT oBrowse

DCBROWSECOL FIELD bau->sprech ;
            HEADER " Ansprechpartner" ;
            WIDTH 13 ;
            COLOR bStdClr ;
            PARENT oBrowse

DCREAD GUI ;
   TITLE cTitel ;
   OPTIONS GetOptions ;
   SETAPPWINDOW ;
   EVAL {|o| o:SetFrameState(XBPDLG_FRAMESTAT_MAXIMIZED), o:show() } ;
   CLEAREVENTS ;
   SETFOCUS @oBrowse

return
****************************************************************************
PROCEDURE Dbesys
IF !DbeLoad( "FOXDBE",.T.)
   DC_WinAlert( "Database-Engine DBFDBE not loaded" )
ENDIF
IF !DbeLoad( "CDXDBE",.T.)
   DC_WinAlert( "Database-Engine CDXDBE not loaded"  )
ENDIF
IF !DbeLoad( "ADSDBE" )
   DC_WinAlert( "Database-Engine ADSDBE not loaded" )
ENDIF
IF !DbeBuild( "FOXCDX", "FOXDBE", "CDXDBE" )
ELSE
   DbeSetDefault("FOXCDX")
   DbeInfo(COMPONENT_ORDER,FOXDBE_LOCKRETRY,20000000)
   DbeInfo(COMPONENT_ORDER,CDXDBE_LOCKRETRY,20000000)
   DbeInfo(COMPONENT_ORDER,FOXDBE_LOCKDELAY,10)
   DbeInfo(COMPONENT_ORDER,CDXDBE_LOCKDELAY,10)
   DbeInfo(COMPONENT_ORDER, FOXDBE_LOCKMODE, LOCKING_EXTENDED)
   DbeInfo(COMPONENT_ORDER, FOXDBE_LIFETIME, 0)
ENDIF
return
**********************************************************************
procedure fvwinit_SetResolut(hpix)

M->oGDL:nDPIFaktor:=GetTextDPI(2)
if M->oGDL:nDPIFaktor>=1.5 .and. hpix>=1080
   ** Bei HD und 150%
   hpix:=768
endif
M->oGDL:aResolut:=AppDesktop():currentSize()
do case
case hpix<=600
   M->oGDL:cHeadFont:="8.Arial Fett Kursiv"
   M->oGDL:cSayFont:="8.Arial"
   M->oGDL:cSayFont2:="10.Arial Fett"
   M->oGDL:cSayFont3:="14.Arial Fett"
   M->oGDL:cBrwFont:="8.Arial"
   M->oGDL:cGetFont:="10.Courier New"
   M->oGDL:cGetFont2:="11.Courier New"
   M->oGDL:cGetFont3:="14.Courier New Fett"
   M->oGDL:nSayWidth:=130
   M->oGDL:nColPixels:=7
   M->oGDL:nRowPixels:=20
   M->oGDL:nSpFakt:=1.00
   M->oGDL:nBrwHoehe:=20
   M->oGDL:cFontSZ:="12.Marlett"
   M->oGDL:cMenuFont:="8.Arial"
case hpix<=768
   M->oGDL:cHeadFont:="8.Arial Fett Kursiv"
   M->oGDL:cSayFont:="10.Arial"
   M->oGDL:cSayFont2:="12.Arial Fett"
   M->oGDL:cSayFont3:="14.Arial Fett"
   M->oGDL:cBrwFont:="10.Arial"
   M->oGDL:cGetFont:="12.Courier New"
   M->oGDL:cGetFont2:="14.Courier New Fett"
   M->oGDL:cGetFont3:="17.Courier New Fett"
   M->oGDL:nSayWidth:=160
   M->oGDL:nColPixels:=8.5
   M->oGDL:nRowPixels:=24
   M->oGDL:nSpFakt:=1.00
   M->oGDL:nBrwHoehe:=24
   M->oGDL:cFontSZ:="14.Marlett"
   M->oGDL:cMenuFont:="8.Arial"
case hpix<=1080
   M->oGDL:cHeadFont:="10.Arial Fett Kursiv"
   M->oGDL:cSayFont:="11.Arial Fett"
   M->oGDL:cSayFont2:="14.Arial Fett"
   M->oGDL:cSayFont3:="16.Arial Fett"
   M->oGDL:cBrwFont:="12.Arial Fett"
   M->oGDL:cGetFont:="14.Courier New Fett"
   M->oGDL:cGetFont2:="15.Courier New Fett"
   M->oGDL:cGetFont3:="18.Courier New Fett"
   M->oGDL:nSayWidth:=190
   M->oGDL:nColPixels:=10
   M->oGDL:nRowPixels:=28
   M->oGDL:nSpFakt:=1.25
   M->oGDL:nBrwHoehe:=28
   M->oGDL:cFontSZ:="16.Marlett"
   M->oGDL:cMenuFont:="9.Arial"
case hpix>1080
   M->oGDL:cHeadFont:="13.Arial Fett Kursiv"
   M->oGDL:cSayFont:="13.Arial"
   M->oGDL:cSayFont2:="16.Arial Fett"
   M->oGDL:cSayFont3:="18.Arial Fett"
   M->oGDL:cBrwFont:="14.Arial Fett"
   M->oGDL:cGetFont:="16.Courier New Fett"
   M->oGDL:cGetFont2:="18.Courier New Fett"
   M->oGDL:cGetFont3:="20.Courier New Fett"
   M->oGDL:nSayWidth:=210
   M->oGDL:nColPixels:=11.5
   M->oGDL:nRowPixels:=32
   M->oGDL:nSpFakt:=1.25
   M->oGDL:nBrwHoehe:=36
   M->oGDL:cFontSZ:="18.Marlett"
   M->oGDL:cMenuFont:="9.Arial"
endcase
#if XPPVER > 2000000
   M->oGDL:nBrwHoehe+=6
#endif
**wg. grerer Fonts
M->oGDL:nSayWidth*=M->oGDL:nDPIFaktor
M->oGDL:nColPixels*=M->oGDL:nDPIFaktor
M->oGDL:nRowPixels*=M->oGDL:nDPIFaktor
M->oGDL:nBrwHoehe*=M->oGDL:nDPIFaktor
return
****************************************************************************
FUNCTION GetTextDPI(art)
** Rckgabe bei art=1 dpi, 2=Zoomfaktor
LOCAL oPS, aTmp

DEFAULT art TO 1

oPS := XbpPresSpace():New():Create( AppDesktop():WinDevice(), ;
                                       {100,100}, GRA_PU_LOENGLISH )
aTmp:= oPS:SetViewport()
oPS:Destroy()
RETURN iif(art=1, aTmp[3]-aTmp[1],round((aTmp[3]-aTmp[1])/96,2))

